﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Linq;

namespace ConsoleApplication1
{
    public class Program
    {
        private static void Main(string[] args)
        {
            //CreatXmlTree(@"d:/demo.xml");
            //string input = "<div>ASDFASDF</div><H1></H1><div>ASDFA1111SDF</div>";
            //string pattern = @"<div>[^<>]\S*</div>";

            //foreach (Match match in Regex.Matches(input, pattern))
            //    Console.WriteLine(match.Value);
            //DataTable d = new DataTable();
            //d.Columns.Add("name");
            //d.Columns.Add("age");
            ////d.TableName = "test";
            //for(int i=0;i<10;i++)
            //{
            //    DataRow dr = d.NewRow();
            //    dr["name"] = "name1" + i;
            //    dr["age"] = "age0" + i;
            //    d.Rows.Add(dr);
            //}
            //string x=DataTable2Xml(d);
            //XmlDocument xd = new XmlDocument();
            //xd.LoadXml(x);
            //xd.Save(@"d:\dtxml.xml");

            DataSet dt = Xml2DataTable(@"d:\dtxml.xml");
            DataTable temp = dt.Tables[0];
            temp.WriteXmlSchema(@"d:\dtxmlbak2.xml");
            temp.WriteXml(@"d:\dtxmlbak3.xml");

            DataSet dt2 = Xml2DataTable(@"d:\dtxmlbak3.xml");
            //foreach(DataRow dr in temp.Rows)
            //{
            //    Console.WriteLine(dr[0].ToString());
            //}
            //string x = DataTable2Xml(temp);
            //XmlDocument xd = new XmlDocument();

            //xd.LoadXml(x);

            //var xmldecl = xd.CreateXmlDeclaration("1.0", "utf-8", null);
            //xd.ImportNode(xmldecl,true);
            //xd.Save(@"d:\dtxmlbak.xml");
            //Form1 f = new Form1(temp);
            //f.Show();
            XmlDocumentReadDemo();
            Console.ReadLine();
        }

        #region 使用XmlDocument方式

        #region XmlDocument读取

        public static void XmlDocumentReadDemo()
        {
            //list
            List<BookModel> bookModeList = new List<BookModel>();

            //使用的时候,首先声明一个XmlDocument对象,然后调用Load方法,从指定的路径加载XML文件.
            XmlDocument doc = new XmlDocument();

            XmlReaderSettings settings = new XmlReaderSettings();
            settings.IgnoreComments = true;//忽略文档里面的注释
            using (XmlReader reader = XmlReader.Create(@"d:/demo.xml", settings))
            {
                doc.Load(reader);
                //doc.Load(@"d:/demo.xml");
                //然后可以通过调用SelectSingleNode得到指定的结点,通过GetAttribute得到具体的属性值.参看下面的代码
                // 得到根节点bookstore
                XmlNode xn = doc.SelectSingleNode("bookstore");
                // 得到根节点的所有子节点
                XmlNodeList xnl = xn.ChildNodes;

                foreach (XmlNode xn1 in xnl)
                {
                    BookModel bookModel = new BookModel();
                    // 将节点转换为元素，便于得到节点的属性值
                    XmlElement xe = (XmlElement)xn1;
                    // 得到Type和ISBN两个属性的属性值
                    bookModel.BookISBN = xe.GetAttribute("ISBN").ToString();
                    bookModel.BookType = xe.GetAttribute("Type").ToString();
                    // 得到Book节点的所有子节点
                    XmlNodeList xnl0 = xe.ChildNodes;
                    bookModel.BookName = xnl0.Item(0).InnerText;
                    bookModel.BookAuthor = xnl0.Item(1).InnerText;
                    bookModel.BookPrice = Convert.ToDouble(xnl0.Item(2).InnerText);

                    bookModeList.Add(bookModel);
                }
            }
            bookModeList.Add(new BookModel());
        }

        #endregion XmlDocument读取

        #region XmlDocument创建或者插入节点

        /// <summary>
        /// 向文件中添加新的数据的时候,
        /// 首先也是通过XmlDocument加载整个文档,
        /// 然后通过调用SelectSingleNode方法获得根结点,
        /// 通过CreateElement方法创建元素,
        /// 用CreateAttribute创建属性,
        /// 用AppendChild把当前结点挂接在其它结点上,
        /// 用SetAttributeNode设置结点的属性.具体代码如下:
        /// </summary>
        public static void XmlDocumentCreateInsertDemo()
        {
            //加载文件并选出要结点:
            XmlDocument doc = new XmlDocument();
            doc.Load(@"d:/demo.xml");
            XmlNode root = doc.SelectSingleNode("bookstore");
            //创建一个结点,并设置结点的属性:
            XmlElement xelKey = doc.CreateElement("test");
            XmlAttribute xelType = doc.CreateAttribute("Type");
            xelType.Value = "testvalue";
            xelKey.SetAttribute("Type", "testvalue2");
            xelKey.SetAttributeNode(xelType);
            //注释节点
            XmlComment xco = doc.CreateComment("这是注释");
            //内容节点
            XmlElement xelAuthor = doc.CreateElement("author");
            xelAuthor.InnerText = "sss";
            xelKey.AppendChild(xelAuthor);
            xelKey.AppendChild(xco);
            root.AppendChild(xelKey);
            doc.Save(@"d:/demov2.xml");
        }

        #endregion XmlDocument创建或者插入节点

        #region XmlDocument 查找删除修改

        /// <summary>
        /// 想要删除某一个结点,直接找到其父结点,
        /// 然后调用RemoveChild方法即可,现在关键的问题是如何找到这个结点,
        /// 上面的SelectSingleNode可以传入一个Xpath表,
        /// 我们通过书的ISBN号来找到这本书所在的结点
        /// </summary>
        public static void XmlDocumentSeachDelUpdateDemo()
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(@"d:/demo.xml");
            XmlNode root = doc.DocumentElement;
            string strPath = string.Format("/bookstore/book[@ISBN=\"{0}\"]", "7-111-19149-6");
            XmlElement selectXe = (XmlElement)root.SelectSingleNode(strPath);
            //删除
            //selectXe.ParentNode.RemoveChild(selectXe);
            selectXe.SetAttribute("Type", "asdfasdf");//也可以通过SetAttribute来增加一个属性
            selectXe.SetAttribute("Typeasdf", "wxcd");//也可以通过SetAttribute来增加一个属性
            selectXe.GetElementsByTagName("title").Item(0).InnerText = "33ee";
            XmlElement appxle = doc.CreateElement("windy");
            appxle.InnerText = "wwws";
            selectXe.AppendChild(appxle);
            doc.Save(@"d:/demod.xml");
        }

        #endregion XmlDocument 查找删除修改

        #endregion 使用XmlDocument方式

        #region 使用XmlTextReader和XmlTextWriter方式

        #region XmlTextReaderDemo

        public static void XmlTextReaderDemo()
        {
            XmlTextReader reader = new XmlTextReader(@"d:/demo.xml");
            List<BookModel> modelList = new List<BookModel>();
            BookModel model = new BookModel();
            while (reader.Read())
            {
                if (reader.NodeType == XmlNodeType.Element)
                {
                    if (reader.Name == "book")
                    {
                        model.BookType = reader.GetAttribute("Type");
                        model.BookISBN = reader.GetAttribute("ISBN");
                    }
                    if (reader.Name == "title")
                    {
                        model.BookName = reader.ReadElementContentAsString();
                    }
                    if (reader.Name == "author")
                    {
                        model.BookAuthor = reader.ReadElementString().Trim();
                    }
                    if (reader.Name == "price")
                    {
                        model.BookPrice = Convert.ToDouble(reader.ReadElementString().Trim());
                    }
                    //for(int i=0;i<reader.AttributeCount;i++)
                    //{
                    //    reader.MoveToAttribute(i);
                    //}
                }

                if (reader.NodeType == XmlNodeType.EndElement)
                {
                    modelList.Add(model);
                    model = new BookModel();
                }
            }
            reader.Close();
            modelList.Add(new BookModel());
        }

        #endregion XmlTextReaderDemo

        #region XmlTextWriterDemo

        /// <summary>
        /// 然后可以通过WriteStartElement和WriteElementString方法来创建元素,
        /// 这两者的区别就是如果有子结点的元素,那么创建的时候就用WriteStartElement,
        /// 然后去创建子元素,创建完毕后,要调用相应的WriteEndElement来告诉编译器,创建完毕,
        /// 用WriteElementString来创建单个的元素,用WriteAttributeString来创建属性
        /// </summary>
        public static void XmlTextWriterDemo()
        {
            XmlTextWriter myXmlTextWriter = new XmlTextWriter(@"d:/demoWriter.xml", null);
            //使用 Formatting 属性指定希望将 XML 设定为何种格式。 这样，子元素就可以通过使用 Indentation 和 IndentChar 属性来缩进。
            myXmlTextWriter.Formatting = Formatting.Indented;
            myXmlTextWriter.WriteStartDocument(true);
            myXmlTextWriter.WriteStartElement("root");
            myXmlTextWriter.WriteComment("我测试XML编写");
            myXmlTextWriter.WriteStartElement("person");
            myXmlTextWriter.WriteAttributeString("name", "windy");
            myXmlTextWriter.WriteAttributeString("age", "20");
            myXmlTextWriter.WriteElementString("city", "wuxi");
            myXmlTextWriter.WriteEndElement();
            myXmlTextWriter.WriteEndElement();
            myXmlTextWriter.Flush();
            myXmlTextWriter.Close();
        }

        #endregion XmlTextWriterDemo

        #endregion 使用XmlTextReader和XmlTextWriter方式

        #region 使用Linq to XML方法

        public static void Ling2XmlDemo()
        {
            #region 读取所有的数据

            //XElement xe = XElement.Load(@"d:/demoLinq.xml");
            ////xe.Descendants
            //var elements = from ele in xe.Elements()
            //               select ele;
            //List<BookModel> modelList = new List<BookModel>();
            //foreach (var ele in elements)
            //{
            //    BookModel model = new BookModel();
            //    model.BookAuthor = ele.Element("author").Value;
            //    model.BookName = ele.Element("title").Value;
            //    model.BookPrice = Convert.ToDouble(ele.Element("price").Value);
            //    model.BookISBN = ele.Attribute("ISBN").Value;
            //    model.BookType = ele.Attribute("Type").Value;

            //    modelList.Add(model);
            //}
            //modelList.Add(new BookModel());

            #endregion 读取所有的数据

            #region 插入一条数据

            //XElement xe = XElement.Load(@"d:/demoLinq.xml");
            //XElement record = new XElement(
            //    new XElement("root",
            //    new XElement("book",
            //    new XAttribute("Type", "选修课"),
            //   new XAttribute("ISBN", "7-111-19149-1"),
            //   new XElement("title", "计算机操作系统"),
            //   new XElement("author", "7-111-19149-1"),
            //   new XElement("price", 28.00))));
            //xe.Add(record);
            //record.Save(@"d:/demoLinq.xml");

            #endregion 插入一条数据

            #region 删除选中的数据

            //XElement xe = XElement.Load(@"d:/demoLinq.xml");
            //string id = "";
            //var elements = from ele in xe.Elements("book")
            //               where (string)ele.Attribute("ISBN") == id
            //               select ele;
            //if (elements.Count() > 0)
            //{
            //    elements.First().Remove();
            //}
            //xe.Save(@"d:/demoLinq.xml");

            #endregion 删除选中的数据

            #region 修改某一记录

            //注意：xml必须需要根节点
            XElement xe = XElement.Load(@"d:/demoLinq.xml");
            string id = "7-111-19149-1";
            var elements = from ele in xe.Elements()
                           where (string)ele.Attribute("ISBN") == id
                           select ele;
            if (elements.Count() > 0)
            {
                XElement first = elements.First();
                ///设置新的属性
                first.SetAttributeValue("Type", "11212");
                ///替换新的节点
                first.ReplaceNodes(
                         new XElement("title", "3435"),
                         new XElement("author", "55656"),
                         new XElement("price", "9999")
                         );
            }
            xe.Save(@"d:/demoLinq.xml");

            #endregion 修改某一记录
        }

        #endregion 使用Linq to XML方法

        #region DataTable TO Xml

        /// <summary>
        /// 将DataTable转成xml
        /// </summary>
        /// <param name="sourceDt"></param>
        /// <returns></returns>
        public static string DataTable2Xml(DataTable sourceDt)
        {
            if (sourceDt != null)
            {
                MemoryStream ms = null;
                XmlTextWriter XmlWt = null;
                try
                {
                    ms = new MemoryStream();
                    //根据ms实例化XmlWt
                    XmlWt = new XmlTextWriter(ms, Encoding.Default);
                    //获取ds中的数据
                    sourceDt.WriteXml(XmlWt);
                    int count = (int)ms.Length;
                    byte[] temp = new byte[count];
                    ms.Seek(0, SeekOrigin.Begin);
                    ms.Read(temp, 0, count);
                    //返回Unicode编码的文本
                    // UnicodeEncoding ucode = new UnicodeEncoding();
                    string returnValue = Encoding.Default.GetString(temp).Trim();
                    return returnValue;
                }
                catch (System.Exception ex)
                {
                    throw ex;
                }
                finally
                {
                    //释放资源
                    if (XmlWt != null)
                    {
                        XmlWt.Close();
                        ms.Close();
                        ms.Dispose();
                    }
                }
            }
            else
            {
                return "";
            }
        }

        #endregion DataTable TO Xml

        public static DataSet Xml2DataTable(string pathFile)
        {
            StringReader stream = null;
            XmlTextReader reader = null;
            try
            {
                DataSet xmlDS = new DataSet();
                //stream = new StringReader(xmlData);
                reader = new XmlTextReader(pathFile);
                xmlDS.ReadXml(reader);
                return xmlDS;
            }
            catch (Exception ex)
            {
                string strTest = ex.Message;
                return null;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
            }
        }
    }
}